All Classes Namespaces Functions Pages
hal::BottomSegmentIterator Class Referenceabstract

`#include <halBottomSegmentIterator.h>`

Inheritance diagram for hal::BottomSegmentIterator:

## Public Member Functions

virtual BottomSegmentIteratorPtr | copy ()=0
virtual BottomSegmentIteratorConstPtr | copy () const =0
virtual void | copy (BottomSegmentIteratorConstPtr bs) const =0
virtual void | toParent (TopSegmentIteratorConstPtr ts) const =0
virtual void | toParseDown (TopSegmentIteratorConstPtr ts) const =0
virtual BottomSegment * | getBottomSegment ()=0
virtual const BottomSegment * | getBottomSegment () const =0
virtual bool | equals (BottomSegmentIteratorConstPtr other) const =0
Public Member Functions inherited from hal::BottomSegment
virtual hal_size_t | getNumChildren () const =0
virtual hal_index_t | getChildIndex (hal_size_t i) const =0
virtual hal_index_t | getChildIndexG (const Genome *childGenome) const =0
virtual bool | hasChild (hal_size_t child) const =0
virtual bool | hasChildG (const Genome *childGenome) const =0
virtual void | setChildIndex (hal_size_t i, hal_index_t childIndex)=0
virtual bool | getChildReversed (hal_size_t i) const =0
virtual void | setChildReversed (hal_size_t child, bool isReversed)=0
virtual hal_index_t | getTopParseIndex () const =0
virtual void | setTopParseIndex (hal_index_t parseIndex)=0
virtual hal_offset_t | getTopParseOffset () const =0
virtual bool | hasParseUp () const =0
virtual hal_index_t | getLeftChildIndex (hal_size_t i) const =0
virtual hal_index_t | getRightChildIndex (hal_size_t i) const =0
Public Member Functions inherited from hal::Segment
virtual void | setArrayIndex (Genome *genome, hal_index_t arrayIndex)=0
virtual void | setArrayIndex (const Genome *genome, hal_index_t arrayIndex) const =0
virtual const Genome * | getGenome () const =0
virtual Genome * | getGenome ()=0
virtual const Sequence * | getSequence () const =0
virtual Sequence * | getSequence ()=0
virtual hal_index_t | getStartPosition () const =0
virtual hal_index_t | getEndPosition () const =0
virtual hal_size_t | getLength () const =0
virtual void | getString (std::string &outString) const =0
virtual void | setCoordinates (hal_index_t startPos, hal_size_t length)=0
virtual hal_index_t | getArrayIndex () const =0
virtual bool | leftOf (hal_index_t genomePos) const =0
virtual bool | rightOf (hal_index_t genomePos) const =0
virtual bool | overlaps (hal_index_t genomePos) const =0
virtual bool | isFirst () const =0
virtual bool | isLast () const =0
virtual bool | isMissingData (double nThreshold) const =0
virtual bool | isTop () const =0
virtual hal_size_t | getMappedSegments (std::set< MappedSegmentConstPtr > &outSegments, const Genome *tgtGenome, const std::set< const Genome * > *genomesOnPath=NULL, bool doDupes=true, hal_size_t minLength=0) const =0
virtual void | print (std::ostream &os) const =0
Public Member Functions inherited from hal::SegmentIterator
virtual void | toLeft (hal_index_t leftCutoff=NULL_INDEX) const =0
virtual void | toRight (hal_index_t rightCutoff=NULL_INDEX) const =0
virtual void | toSite (hal_index_t position, bool slice=true) const =0
Public Member Functions inherited from hal::SlicedSegment
virtual void | toReverse () const =0
virtual void | toReverseInPlace () const =0
virtual hal_offset_t | getStartOffset () const =0
virtual hal_offset_t | getEndOffset () const =0
virtual void | slice (hal_offset_t startOffset=0, hal_offset_t endOffset=0) const =0
virtual bool | getReversed () const =0

## Friends

class | counted_ptr< BottomSegmentIterator >
class | counted_ptr< const BottomSegmentIterator >

## Detailed Description

Interface for bottom segment iterator exposes the bottom segment interface and some new methods for jumping around the genome. Always hidden in smart pointers in the public interface.

## Member Function Documentation

virtual BottomSegmentIteratorPtr hal::BottomSegmentIterator::copy | ( |  | ) |

pure virtual

Return a new copy of the iterator

virtual BottomSegmentIteratorConstPtr hal::BottomSegmentIterator::copy | ( |  | ) | const

pure virtual

Return a new copy of the iterator

virtual void hal::BottomSegmentIterator::copy | ( | BottomSegmentIteratorConstPtr | bs | ) | const

pure virtual

Copy an input iterator. More efficient than the above methods as no new iterator needs to be allocated

Parameters

  ts | Iterator to copy

virtual bool hal::BottomSegmentIterator::equals | ( | BottomSegmentIteratorConstPtr | other | ) | const

pure virtual

Test equality with other iterator (current implementation does not take into account reverse state or offsets – too review)

Parameters

  other | Iterator to test equality to

virtual BottomSegment* hal::BottomSegmentIterator::getBottomSegment | ( |  | ) |

pure virtual

DEPRECATED

virtual const BottomSegment* hal::BottomSegmentIterator::getBottomSegment | ( |  | ) | const

pure virtual

DEPRECATED

virtual void hal::BottomSegmentIterator::toParent | ( | TopSegmentIteratorConstPtr | ts | ) | const

pure virtual

Move the iterator to the parent segment of a given iterator

Parameters

  ts | Iterator whose parent to move to

virtual void hal::BottomSegmentIterator::toParseDown | ( | TopSegmentIteratorConstPtr | ts | ) | const

pure virtual

Move the iterator down to the bottom segment containg the start position of the given iterator in the same genome

Parameters

  ts | Top iterator to parse down on

The documentation for this class was generated from the following file:

- inc/halBottomSegmentIterator.h